Namespace WinForms
    Public Class RemoteTransactionForm

        Public Event FormReadDevice()
        Public Event FormReadFile()
        Public Event FormProcessExecute()
        Public Event FormTabPreview()
        Public Event FormTabError()
        Public Event FormPreviewDelete()
        Public Event FormErrorDelete()
        Public Event FormPreviewSave()
        Public Event FormErrorSave()
        Public Event FormPreviewDeleteAll()
        Public Event FormErrorDeleteAll()
        Public Event FormErrorSaveToProcess(ByVal proccessAll As Boolean)
        Public Event FormPreviewExportToCSV()
        Public Event FormErrorExportToCSV()
        Public Event FormPreviewProcess As EventHandler

        Private Sub MenuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileExit.Click
            Me.Close()
        End Sub

        Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
            Me.Close()
        End Sub

        Private Sub ReadButtonDevice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadButtonDevice.Click
            RaiseEvent FormReadDevice()
        End Sub

        Private Sub ReadButtonOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadButtonOpen.Click
            RaiseEvent FormReadFile()
        End Sub

        Private Sub ProcessButtonExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProcessButtonExecute.Click
            RaiseEvent FormProcessExecute()
        End Sub

        Private Sub RemoteTabControl_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RemoteTabControl.SelectedIndexChanged
            If RemoteTabControl.SelectedTab Is TabPreview Then
                RaiseEvent FormTabPreview()
            ElseIf RemoteTabControl.SelectedTab Is TabErrors Then
                RaiseEvent FormTabError()
            End If
        End Sub



        Private Sub AllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AllToolStripMenuItem.Click
            RaiseEvent FormPreviewDeleteAll()
        End Sub

        Private Sub SelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectedToolStripMenuItem.Click
            RaiseEvent FormPreviewDelete()
        End Sub

        Private Sub AllToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AllToolStripMenuItem1.Click
            RaiseEvent FormErrorDeleteAll()
        End Sub

        Private Sub CurrentToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CurrentToolStripMenuItem.Click
            RaiseEvent FormErrorDelete()
        End Sub

        Private Sub ToolStripButtonErrorSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonErrorSave.Click
            RaiseEvent FormErrorSave()
        End Sub

        Private Sub AllToolStripMenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AllToolStripMenuItem2.Click
            RaiseEvent FormErrorSaveToProcess(True)
        End Sub

        Private Sub CurrentToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CurrentToolStripMenuItem1.Click
            RaiseEvent FormErrorSaveToProcess(False)
        End Sub


        Private Sub ToolStripButtonPreviewSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonPreviewSave.Click
            RaiseEvent FormPreviewSave()
        End Sub

        Private Sub GridToolStripButtonExport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GridToolStripButtonExport.Click
            RaiseEvent FormPreviewExportToCSV()
        End Sub

        Private Sub ErrorGridButtonExport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ErrorGridButtonExport.Click
            RaiseEvent FormErrorExportToCSV()
        End Sub

        Private Sub dgvPreview_AfterCellUpdate(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.CellEventArgs) Handles dgvPreview.AfterCellUpdate
            RaiseEvent FormPreviewSave()

        End Sub

        Private Sub dgvPreview_AfterRowsDeleted(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgvPreview.AfterRowsDeleted
            RaiseEvent FormPreviewSave()
        End Sub

        Private Sub dgvPreview_AfterRowUpdate(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.RowEventArgs) Handles dgvPreview.AfterRowUpdate
            RaiseEvent FormPreviewSave()
        End Sub

        
        Private Sub dgvErrors_AfterCellUpdate(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.CellEventArgs) Handles dgvErrors.AfterCellUpdate
            RaiseEvent FormErrorSave()
        End Sub

        Private Sub dgvErrors_AfterRowsDeleted(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgvErrors.AfterRowsDeleted
            RaiseEvent FormErrorSave()
        End Sub

        Private Sub dgvErrors_AfterRowUpdate(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.RowEventArgs) Handles dgvErrors.AfterRowUpdate
            RaiseEvent FormErrorSave()
        End Sub

        Private Sub ToolStripPreviewProcess_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripPreviewProcess.Click
            RaiseEvent FormPreviewProcess(sender, e)
        End Sub
    End Class
End Namespace